import os
from logging import config as cf, getLogger
from framework.env_config import get_config
from framework.base import get_project_path


def build_logger(config, name='root'):
    if 'handlers' in config and 'file' in config['handlers']:
        file = config['handlers']['file']
        path = os.path.join(get_project_path(), file["filename"])
        os.makedirs(os.path.split(path)[0], exist_ok=True)
        file["filename"] = os.path.abspath(path)
    cf.dictConfig(config)
    return getLogger(name)


config = get_config(__name__)
logger = build_logger(config, name=config['use'] if 'use' in config else None) if config else None
