from concurrent.futures import ProcessPoolExecutor
from framework.env_config import get_config
from functools import partial, wraps


config = get_config(__name__)
process_pool = ProcessPoolExecutor(max_workers=config['max-workers'] or 2)


def process(func=None):
    if func is None:
        return partial(process)

    @wraps(func)
    def wrap(*args, **kwargs):
        return process_pool.submit(func, *args, **kwargs)

    return wrap
